#define LevII 1
#define MW    1
#undef MW
#define MSC   1
#undef MSC
#define X11   4
#define X11B  5
#define XUNMAPPED 6
#define GASP_INC
#ifdef GRASP_INC
#ifdef ANSI
/* #error "grsys.h must precede grasp.h" */
#endif
#endif
#ifndef GRSYS_INC
#define GRSYS_INC 1
#endif
/*
 *     grsys.H
 *
 *  Procedure prototypes for routines which are called from
 *  grgddm etc. They are not normally called explicitly from
 *  user programs.
 *
 *  !!! include grsys.h BEFORE grasp.h !!!
 *
 */

/* Include files for lower level library (Metawindows) */

#include <stdio.h>

#ifdef MW
#include <grconst.h>
#include <grports.h>
#include <grextrn.h>
#else 
#include <sys/types.h>

#include "X11/X.h"
#include "X11/Xlib.h"
#include "X11/keysym.h"
#include "X11/HPkeysym.h"
#include "X11/cursorfont.h"
#include "X11/Xutil.h"

#endif /* MW */
/* Undefine Metawindows definitions defined in grasp.h */

#undef White
#undef EGA
#undef VGA

#define WAIT   0           /* wait in grgetc until event or timeout */
#define NOWAIT 1

#define BACKSP      8
#define CR         13  /* ASCII carriage return  */
#define SPACE      32


#define FUNKEYBASE 58  /* F1 extended code is 59 */
#define UP        -72
#define LEFT      -75
#define RIGHT     -77
#define DOWN      -80
#define DEL       -83
#define INSERT    -82
#define HOME      -71
#define END       -79
 
#define XFUNKEYBASE  (XK_F1 - 1)

#define  EGA640x350 1
#define EGA640x480  2


/* HP C converts floats to doubles when they are passed as parameters.
 * We need to work in floats because fortran source does. With HP C
 * this will need (at least) extra casting in routines such as grutod.
 *
 * From GCC manual:- "When compiling functions that return `float', PCC
 * converts up to a double. GNU CC actually returns a `float'."
 * So in ANSI we shall use floats. 
 */
#ifdef ANSI
#define real float
#else
#define real double
#endif 
#define version_number "Grasp 2.0 (1 June 92)"
#define ENVUNSET -9999
#ifdef ANSI
extern int  grXtoP( real x);      /* Device X to screen coordinates */
extern int  grYtoP( real y);      /* Device Y to screen coordinates */
extern real grPtoX( int  x);      /* Pixels to device X coordinates */
extern real grPtoY( int  y);      /* Pixels to device Y coordinates */
extern void grmvpx(int x, int y); /* Move pen in pixel units        */
extern void grdrpx(int x, int y); /* Draw pen in pixel units        */
extern int  grkbd(void);          /* read keyboard using BIOS       */
extern int  grgetc(int nowait);   /* read keyboard and mouse button */
extern int  grgetm(void);         /* read mouse position and flags  */
extern int  grmapc(int ch);       /* map characters                 */
extern void grerr(int type);      /* Error handler                  */
extern void grname                /* Set file name for plot etc.    */
  ( char *name, char *filename, int length,
    char *grenv, char *defaultname );
void arcpie ( real xcentre, real ycentre, real angle, int type);
#else /* ANSI */
extern int  grXtoP();      /* Device X to screen coordinates */
extern int  grYtoP( );      /* Device Y to screen coordinates */
extern real grPtoX( );      /* Pixels to device X coordinates */
extern real grPtoY( );      /* Pixels to device Y coordinates */
extern void grmvpx(); /* Move pen in pixel units        */
extern void grdrpx(); /* Draw pen in pixel units        */
extern int  grkbd();          /* read keyboard using BIOS       */
extern int  grgetc();   /* read keyboard and mouse button */
extern int  grgetm();         /* read mouse position and flags  */
extern int  grmapc();       /* map characters                 */
extern void grerr();      /* Error handler                  */
extern void grname();                /* Set file name for plot etc.    */
extern void grarcpie();

#endif /* ANSI */
extern unsigned int  gr_ChW;      /* Character width  in pixels     */
extern unsigned int  gr_ChH;      /* Character height in pixels     */
extern unsigned char gr_ChO;      /* Character offset in pixels     */
extern int gr_Str;                /* Output stream                  */
extern int gr_Scr;                /* Screen selected                */
extern int gr_Plo;                /* Plotter selected               */
extern int gr_Xpx;                /* Screen width  in pixels        */
extern int gr_Ypx;                /* Screen height in pixels        */
extern real gr_Xpo;               /* Current X position             */
extern real gr_Ypo;               /* Current Y position             */
extern int gr_ft;                 /* FillType (for grpie)           */


extern int gr_mx, gr_my;          /* Mouse position                 */

#ifdef X11
extern      char                 *tw;
extern      Display              *display;
extern      Window               main_win, win1,win2;
extern      XSetWindowAttributes attributes;
extern      XFontStruct          *fontinfo; 
extern      GC                   gc;
extern      Visual               *visual;
extern      int                  ddepth;
extern      XGCValues            gr_values;
extern      int                  underline_mode;
extern      int                  vertical_text;
extern      Cursor       cursor, arrow_cursor, cross_cursor, plus_cursor;
#endif


/* Define rect struct if not MetaWindows implementation */
#ifndef MW
 typedef struct {int Xmin; int Ymin; int Xmax; int Ymax; } rect;
#endif

extern rect gr_vp;           /* Viewport coordinates in pixels     */
extern rect gr_da;           /* Display area coordinates in pixels */
extern FILE *gr_PF;          /* Plot file handle                   */


/* the follow have been moved from grasp.c: they're now needed in grarc.c */
#define Xpix gr_Xpx
#define Ypix gr_Ypx
#define Xpos gr_Xpo                  /* Current pen position                 */
#define Ypos gr_Ypo
#define DisplayArea gr_da           /* Rectangle for clearing screen         */

/* the following variants of save/rest are used by grmenu          */
#ifdef ANSI
extern char *grsavr(char *block, long *size, rect area);  /* Save screen contents    */
extern void grrstr(char *block, rect *area);               /* Restore screen contents */
#else /* ANSI */
extern char *grsavr();  /* Save screen contents    */
extern void grrstr();               /* Restore screen contents */
#endif /* ANSI */

extern char *getenv();

extern int currentFont ; 

/* This struct is now global. needed by grgddm */
#ifdef ANSI
typedef struct {
  signed char type;                   /* BitMap or Stroke */
  signed char width, height, offset;  /* in pixels        */
  int  bufsize;                       /* for malloc       */
  char *buffer;                       /* NULL until font is loaded    */
  char *X11font;                      /* nearest X11 font */
  XFontStruct *fontinfo;               /* NULL until X11 font loaded */
} font_struct;
#else
typedef struct {
  char type;                   /* BitMap or Stroke */
  char width, height, offset;  /* in pixels        */
  int  bufsize;                       /* for malloc       */
  char *buffer;                       /* NULL until font is loaded    */
  char *X11font;                      /* nearest X11 font */
  XFontStruct *fontinfo;               /* NULL until X11 font loaded */
} font_struct;
#endif





extern font_struct font[]; 


#define maxlen 100  /* max length of strings (excluding null) */

